package com.thinker.bishi.saima;

import java.util.Arrays;
import java.util.Scanner;

/**
 * @author lzh
 * <p href="http://exercise.acmcoder.com/online/online_judge_ques?ques_id=1500&konwledgeId=134">
 *     http://exercise.acmcoder.com/online/online_judge_ques?ques_id=1500&konwledgeId=134
 * </p>
 *
 */
public class StreetLamp {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int num = in.nextInt();
        int len = in.nextInt();
        int[] lamp = new int[num];
        for(int i=0;i<num;i++){
            lamp[i] = in.nextInt();
        }
        Arrays.sort(lamp);
        double max = Double.MIN_VALUE;
        for(int i=1;i<num;i++){
            double diff = lamp[i] - lamp[i-1];
            if(diff > max){
                max = diff;
            }
        }
        double left = lamp[0];
        double right = len - lamp[num-1];
        if(left>right && left>max/2) System.out.printf("%.2f",left);
        if(right>left && right>max/2) System.out.printf("%.2f",right);
        else System.out.printf("%.2f",max/2);
    }
}
